import java.util.Random;

public class Zahlenraten
{
    Random zufall = new Random(System.currentTimeMillis());
    //Beispiel: dezimal 128
    public int[] zu_ratende_zahl = {1,0,0,0, 0,0,0,0};
 
    //Generation als Daten == DNAs
    //20 DNAs der Bitlnge 8
    public int[][] dna         = new int[20][8];
    public int[]   dna_fehler  = new int[20];
    //Merker fr die besten DNAs 
    public int[][] beste        = new int[5][8];
    public int[]   beste_fehler = new int[5];

    public void initialisieren()
    {
        for(int i=0;i<dna.length;i++)
            for(int k=0;k<dna[i].length;k++)
                dna[i][k]=zufall.nextInt(2);
    }

    public void findeBeste()
    {
        //1. Berechne alle Fehler:        
        for(int i=0;i<dna.length;i++)
            dna_fehler[i]=fehler(dna[i]);        
        //2. Besten herausgreifen, wenn nicht bereits genommen:
        
        for(int i=0;i<beste.length;i++)
        {
            int fehler_aktuell = Integer.MAX_VALUE;
            int stelle=-1;
            for(int k=0;k<dna.length;k++)
            {
                if(dna_fehler[k]!=-1 && dna_fehler[k]<=fehler_aktuell)
                {
                     fehler_aktuell = dna_fehler[k];
                     stelle=k;
                }
            }
            beste_fehler[i]=dna_fehler[stelle];
            dna_fehler[stelle]=-1;
            for(int p=0;p<beste[i].length;p++)
                beste[i][p]=dna[stelle][p];
        }
    }

    void bildeNeueGeneration()
    {
        //Beste bernehmen in neue Generation.
        for(int i=0;i<beste.length;i++)
        {
            for(int p=0;p<beste[i].length;p++)
                dna[i][p]=beste[i][p];
        }

        //Beim Rest der neuen Generation rekombinieren:
        for(int i=beste.length;i<dna.length;i++)
        {
            //1. zufllig zwei Beste whlen
            int nr1 = zufall.nextInt(beste.length);
            int nr2 = zufall.nextInt(beste.length);
            while(nr1==nr2)
                nr2 = zufall.nextInt(beste.length);
            //2. Bitweise entscheiden, von wem das Bit des Neuen
            //   genommen wird.
            for(int p=0;p<beste[0].length;p++)
            {
                if(zufall.nextInt(2)==0)
                    dna[i][p]=beste[nr1][p];          
                else
                    dna[i][p]=beste[nr2][p];          
            }
        }
    }

    public int fehler(int[] testzahl)
    {
        //Hamiltonabstand zwischen Tetzahl und zu ratender Zahl
        //bilden:
        int hamilton=0;
        for(int i=0;i<testzahl.length;i++)
            if(testzahl[i]!=zu_ratende_zahl[i])
                hamilton++;
        return hamilton;
    }

    public void raten()
    {
         initialisieren();
         int bester_fehler=Integer.MAX_VALUE;
         while(bester_fehler!=0)
         {
              findeBeste();
              //den Besten extrahieren
     //Ausgaben
              System.out.print("Bester Fehler:"+beste_fehler[0]+" Muster:");
              for(int p=0;p<beste[0].length;p++)
                  System.out.print(beste[0][p]);
              System.out.println();

              bildeNeueGeneration();

              bester_fehler=beste_fehler[0]; 
         }
    }

    public static void main(String[] args)
    {
         Zahlenraten z = new Zahlenraten();
         z.raten();
    }
}